//+------------------------------------------------------------------+
//|                                                   SIXPERROBOTmq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006"
#property link      "http://www.mrtools1955@aol.com"

// A reliable expert, use it on 5 min charts (GBP is best) with 150/pips profit limit. 
// . No worries, check the results 
extern double BullBearPeriod     = 5;
extern double trailingStop       = 15;            // trail stop in points
extern double takeProfit         = 150;            // recomended  no more than 150
extern double stopLoss           = 45;             // do not use s/l
extern double slippage           = 3;
extern double Slw                = 8;            //ttm stoch
extern double Pds                = 13;           //ttm stoch
extern double Slwsignal          = 9;           //ttm stoch
extern bool   lFlagUseHourTrade  = False;
extern int    nFromHourTrade     = 0;
extern int    nToHourTrade       = 23;
//---- Money Management
extern double Lots               = 1;
extern bool MM                   = true; //Use Money Management or not
extern int Risk                  = 10; //10%

extern string nameEA             = "SIXPER ROBOT";  // EA identifier. Allows for several co-existing EA with different values

double bull,bear;
double val1, val2;
double sarCurrent, sarPrevious, momCurrent, momPrevious, macdHistCurrent, macdSignalCurrent;
double realTP, realSL,b,s,sl,tp;

bool isBuying = false, isSelling = false, isClosing = false;
int cnt, ticket;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//-------------------------------------------------------------------+
//         Money Management                                          |
//-------------------------------------------------------------------+
double LotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
	  if (lotMM < 0.1) lotMM = Lots;
	  if (lotMM > 1.0) lotMM = MathCeil(lotMM);
	  if  (lotMM > 100) lotMM = 100;
	  return (lotMM);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   // Check for invalid bars and takeprofit
   if(Bars < 200) {
      Print("Not enough bars for this strategy - ", nameEA);
      return(-1);
   }
  
   calculateIndicators();                      // Calculate indicators' value   
   
   // Control open trades
   if(MM==true) Lots = LotSize(); //Adjust the lot size
   int totalOrders = OrdersTotal();
   int numPos = 0;
   for(cnt=0; cnt<totalOrders; cnt++) {        // scan all orders and positions...
      OrderSelect(cnt, SELECT_BY_POS);         // the next line will check for ONLY market trades, not entry orders
      if(OrderSymbol() == Symbol() && OrderType() <= OP_SELL ) {   // only look for this symbol, and only orders from this EA      
         numPos++;
         if(OrderType() == OP_BUY) {           // Check for close signal for bought trade
               
            if(trailingStop > 0) {             // Check trailing stop
               if(Bid-OrderOpenPrice() > trailingStop*Point) {
                  if(OrderStopLoss() < (Bid - trailingStop*Point))
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-trailingStop*Point,OrderTakeProfit(),0,Blue);
               }
            }
         } else {                              // Check sold trade for close signal
            
            if(trailingStop > 0) {             // Control trailing stop
               if(OrderOpenPrice() - Ask > trailingStop*Point)
                {
                  if(OrderStopLoss() == 0 || OrderStopLoss() > Ask + trailingStop*Point)
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+trailingStop*Point,OrderTakeProfit(),0,Red);
               }           
            } 
         }
      }
   }
    if (lFlagUseHourTrade){
      if (!(Hour()>=nFromHourTrade && Hour()<=nToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
          } else Comment("");
          }else Comment("");
   
   // If there is no open trade for this pair and this EA
   if(numPos < 1) {   
      if(AccountFreeMargin() < 1000*Lots) {
         Print("Not enough money to trade ", Lots, " Lots. Strategy:", nameEA);
         return(0);
      }
      
      if(isBuying && !isSelling && !isClosing) {  // Check for BUY entry signal
         sl = Ask - stopLoss * Point;
         tp = Bid + takeProfit * Point;
         
        // ticket = OrderSend(OP_BUY,lots,Ask,slippage,realSL,realTP,nameEA,16384,0,Red);  // Buy
         //OrderSend(OP_BUY,lots,Ask,slippage,realSL,realTP,0,0,Red);
         OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,sl,tp,nameEA+CurTime(),0,0,Green);
         Comment(sl);
         if(ticket < 0)
            Print("OrderSend (",nameEA,") failed with error #", GetLastError());
         prtAlert("Day Trading: Buying"); 
      }
      if(isSelling && !isBuying && !isClosing) {  // Check for SELL entry signal
          sl = Bid + stopLoss * Point;
          tp = Ask - takeProfit * Point;
        // ticket = OrderSend(NULL,OP_SELL,lots,Bid,slippage,realSL,realTP,nameEA,16384,0,Red); // Sell
         OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,sl,tp,nameEA+CurTime(),0,0,Red);
         if(ticket < 0)
            Print("OrderSend (",nameEA,") failed with error #", GetLastError());
         prtAlert("Day Trading: Selling"); 
      }
   }
   return(0);
}

void calculateIndicators() {    // Calculate indicators' value   
 
double oTYP0=0, oTYP1=0, oTYP2=0, oTYP3=0, oTYP4=0, oTYP5=0;
   
   bull = iBullsPower(NULL,0,BullBearPeriod,PRICE_CLOSE,0);
   bear = iBearsPower(NULL,0,BullBearPeriod,PRICE_CLOSE,0);
Comment("bull+bear= ",bull + bear);
   sarCurrent          = iSAR(NULL,0,0.02,0.2,0);           // Parabolic Sar Current
   sarPrevious         = iSAR(NULL,0,0.02,0.2,1);           // Parabolic Sar Previuos
   momCurrent          = iMomentum(NULL,0,5,PRICE_CLOSE,0); // Momentum Current
   momPrevious         = iMomentum(NULL,0,5,PRICE_CLOSE,1); // Momentum Previous
   macdHistCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   macdSignalCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   oTYP0=(High[0]+Low[0]+Close[0]+Close[0])/4;
   oTYP1=(High[1]+Low[1]+Close[1]+Close[1])/4;
   oTYP2=(High[2]+Low[2]+Close[2]+Close[2])/4;
   oTYP3=(High[3]+Low[3]+Close[3]+Close[3])/4;
   oTYP4=(High[4]+Low[4]+Close[4]+Close[4])/4;
   oTYP5=(High[5]+Low[5]+Close[5]+Close[5])/4;

   double val1 = iCustom(NULL, 0, "TTMStoch", Slw, Pds, Slwsignal, 0, 0);
   double val2 = iCustom(NULL, 0, "TTMStoch", Slw, Pds, Slwsignal, 1, 0);
   
  
    b = 1 * Point + iATR(NULL,0,5,1) * 1.5;
    s = 1 * Point + iATR(NULL,0,5,1) * 1.5;
    //Check for BUY, SELL, and CLOSE signal
    isBuying  = (sarCurrent<=Close[0] && sarPrevious<sarCurrent && momCurrent>momPrevious && macdHistCurrent>macdSignalCurrent && val1 > val2 && oTYP5<oTYP4
     && oTYP4<oTYP3 && oTYP3<oTYP2 && oTYP2<oTYP1 && oTYP1<oTYP0 && bull+bear>0);
    isSelling = (sarCurrent>=Close[0] && sarPrevious>sarCurrent && momCurrent<momPrevious && macdHistCurrent<macdSignalCurrent && val1 < val2 && oTYP5>oTYP4 
    && oTYP4>oTYP3 && oTYP3>oTYP2 && oTYP2>oTYP1 && oTYP1>oTYP0 && bull+bear<0);
    //isBuying  = (bull+bear>0);
    //isSelling = (bull+bear<0);

   isClosing = false;
}

void prtAlert(string str = "") {
   Print(str);
   Alert(str);
   //SpeechText(str,SPEECH_ENGLISH);
   // SendMail("Subject EA",str);
}

//+------------------------------------------------------------------+